#include <string.h>
#include <stdlib.h>
#include "bitmap.h"

BITMAP *new_bitmap(int x, int y) {
  BITMAP *bitmap;
  //int len;

  bitmap = (BITMAP *)malloc(sizeof(BITMAP));
  bitmap->width  = x;
  bitmap->height = y;
  bitmap->len = x*y/8;
  if (x*y%8) bitmap->len++;
  bitmap->data = (char *)malloc(bitmap->len);
  return(bitmap);
}

void destroy_bitmap(BITMAP *bitmap) {
  free(bitmap->data);
  free(bitmap);
}

int get_bit(BITMAP *bitmap, int index) {
  unsigned char t;

  if (index>=bitmap->width*bitmap->height) return(0);

  t = 1 << index%8;
  t &= bitmap->data[index/8];
  if (t>0) return(1);
  return(0);
}

void set_bit(BITMAP *bitmap, int index) {
  unsigned char t;

  if (index>=bitmap->width*bitmap->height) return;

  t = 1 << index%8;
  //printf("#%d: \t %02X  |  %02X  =  ", index,bitmap->data[index/8], t);  
  bitmap->data[index/8] |= t;
  //printf("%7d   %02X\n", index, bitmap->data[index/8]);
}

void clear_bitmap(BITMAP *bitmap) {
  //bzero(bitmap->data, bitmap->len);
  memset(bitmap->data, 0, bitmap->len);

}
